--- old/usr/src/cmd/sgs/libld/common/libld.msg	2019-02-24 19:19:11.964074938 +0000
+++ new/usr/src/cmd/sgs/libld/common/libld.msg	2019-02-24 19:19:11.979030160 +0000
@@ -36,7 +36,7 @@
 
 #
 # TRANSLATION_NOTE -- Beginning of USAGE message
-# 	The following messages are the usage messages for the ld command.
+#	The following messages are the usage messages for the ld command.
 #	Tab characters (\t) are used to align the messages.
 #
 #	Each usage message starts with \t, and if the message has more than one
@@ -54,9 +54,9 @@
 #	In C locale, the first 3 messages would look like the following:
 #
 #	usage: ld [-6:abc:.....] file(s)
-#        	[-a]            create an absolute file
-#        	[-b]            do not do special PIC relocations in a.out
-#        	[-c file]       record configuration 'file'
+#		[-a]		create an absolute file
+#		[-b]		do not do special PIC relocations in a.out
+#		[-c file]	record configuration 'file'
 #
 @ MSG_ARG_USAGE		"usage: ld [-%s] file(s)\n"
 @ MSG_ARG_DETAIL_3	"\t[-32]\t\tenforce a 32-bit link-edit\n"
@@ -251,6 +251,8 @@
 			 text\n"
 @ MSG_ARG_DETAIL_ZTW	"\t[-z textwarn]\twarn if there are relocations \
 			 against text\n"
+@ MSG_ARG_DETAIL_ZTY	"\t[-z type=type]\tspecify the type of object \
+			 (exec, kmod, reloc, shared)\n"
 @ MSG_ARG_DETAIL_ZWRAP	"\t[-z wrap=symbol], [-wrap=symbol], [--wrap=symbol]\n\
 			 \t\t\twrap symbol references\n"
 @ MSG_ARG_DETAIL_ZVER	"\t[-z verbose]\t\
@@ -353,13 +355,13 @@
 
 #
 # TRANSLATION_NOTE
-# 	The following 7 messages are the message to print the
+#	The following 7 messages are the message to print the
 #	following example messages.
 #
 #Text relocation remains		      referenced
 #    against symbol		    offset	in file
-#str                                 0x14      	main.o
-#printf                              0x1c      	main.o
+#str				     0x14	main.o
+#printf				     0x1c	main.o
 #
 #	The first two lines are the header, and the next msgid
 #	is the format string for the header.
@@ -476,7 +478,7 @@
 
 @ MSG_SCN_DWFOVRFLW	"%s: section %s: encoded DWARF data exceeds \
 			 section size"
-@ MSG_SCN_DWFBADENC	"%s: section %s: invalid DWARF encoding: %#x"                         
+@ MSG_SCN_DWFBADENC	"%s: section %s: invalid DWARF encoding: %#x"
 
 # Symbol processing errors
 
@@ -543,11 +545,11 @@
 
 #
 # TRANSLATION_NOTE
-# 	The following 7 messages are the message to print the
+#	The following 7 messages are the message to print the
 #	following example messages.
 #
 #Undefined			first referenced
-# symbol  			    in file
+# symbol			    in file
 #inquire                            halt_hold.o
 #
 @ MSG_SYM_FMT_UNDEF	"%s\t\t\t%s\
@@ -694,6 +696,7 @@
 @ MSG_REJ_HWCAP_2	"file %s: hardware capability (CA_SUNW_HW_2) \
 			 unsupported: %s"
 @ MSG_REJ_ARCHIVE	"file %s: invalid archive use"
+@ MSG_REJ_KMOD		"file %s: kernel modules can't be link-edit input"
 
 # Guidance messages
 @ MSG_GUIDE_SUMMARY	"see ld(1) -z guidance for more information"
@@ -706,6 +709,7 @@
 @ MSG_GUIDE_TEXT	"position independent (PIC) code recommended for \
 			 shared objects"
 @ MSG_GUIDE_UNUSED	"removal of unused dependency recommended: %s"
+@ MSG_GUIDE_KMOD	"use -z type=kmod, not -r -dy"
 
 @ _END_
 
@@ -879,6 +883,9 @@
 @ MSG_SYM_L_START	"START_"
 @ MSG_SYM_L_START_U	"_START_"
 
+@ MSG_SYM_SECBOUND_START "__start_"
+@ MSG_SYM_SECBOUND_STOP "__stop_"
+
 # Support functions
 
 @ MSG_SUP_VERSION	"ld_version"
@@ -898,10 +905,10 @@
 @ MSG_SUP_INSEC		"ld_input_section"
 @ MSG_SUP_SEC		"ld_section"
 
-# 
+#
 # Message previously in 'ld'
 #
-# 
+#
 @ _START_
 
 # System error messages
@@ -962,11 +969,13 @@
 @ MSG_MARG_FILTER_AUX	"auxiliary filter option (-f, --auxiliary)"
 @ MSG_MARG_FILTER	"filter option (-F, --filter)"
 @ MSG_MARG_OUTFILE	"output object option (-o, --output)"
-@ MSG_MARG_REL		"relocatable object option (-r, --relocatable)"
+@ MSG_MARG_REL		"relocatable object option (-r, --relocatable, \
+			-z type=reloc)"
 @ MSG_MARG_RPATH	"runpath option (-R, -rpath)"
-@ MSG_MARG_SO		"shared object option (-G, -shared)"
+@ MSG_MARG_SO		"shared object option (-G, -shared, -z type=shared)"
 @ MSG_MARG_SONAME	"soname option (-h, --soname)"
 @ MSG_MARG_STRIP	"strip option (-s, --strip-all)"
+@ MSG_MARG_TYPE_KMOD	"-z type=kmod"
 
 # Entrance criteria messages
 
@@ -979,7 +988,7 @@
 # The next message is a format string for a title. The title is composed of
 # two lines. In C locale, it would look like:
 #
-# 	output		input		new
+#	output		input		new
 #	section		section		displacement	size
 #
 # The \t characters are used for alignment.  (output section), (input section),
@@ -1307,7 +1316,7 @@
 @ MSG_STR_PATH		"%s/%s"
 @ MSG_STR_STRNL		"%s\n"
 @ MSG_STR_NL		"\n"
-@ MSG_STR_CAPGROUPID 	"CAP_GROUP_%d"
+@ MSG_STR_CAPGROUPID	"CAP_GROUP_%d"
 
 @ MSG_STR_LD_DYNAMIC	"dynamic"
 @ MSG_STR_SYMBOLIC	"symbolic"
@@ -1443,6 +1452,7 @@
 @ MSG_ARG_DEFERRED	"deferred"
 @ MSG_ARG_NODEFERRED	"nodeferred"
 @ MSG_ARG_ASSDEFLIB	"assert-deflib"
+@ MSG_ARG_TYPE		"type"
 
 @ MSG_ARG_LCOM		"L,"
 @ MSG_ARG_PCOM		"P,"
@@ -1492,6 +1502,12 @@
 @ MSG_ARG_GUIDE_NO_TEXT		"notext"
 @ MSG_ARG_GUIDE_NO_UNUSED	"nounused"
 
+# -z type= strings
+@ MSG_ARG_TYPE_RELOC	"reloc"
+@ MSG_ARG_TYPE_EXEC	"exec"
+@ MSG_ARG_TYPE_SHARED	"shared"
+@ MSG_ARG_TYPE_KMOD	"kmod"
+
 # Environment variable strings
 
 @ MSG_LD_RUN_PATH	"LD_RUN_PATH"
